Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemSetView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemSetView.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemSetView.cs	(revision 2655)
@@ -0,0 +1,70 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Core.Views {
+  public partial class ItemSetView<T> : ItemCollectionView<T> where T : class, IItem {
+    public IObservableSet<T> ItemSet {
+      get { return (IObservableSet<T>)Object; }
+      set { base.Object = value; }
+    }
+
+    private Dictionary<T, ListViewItem> listViewItemDictionary;
+    protected Dictionary<T, ListViewItem> ListViewItemDictionary {
+      get { return listViewItemDictionary; }
+    }
+
+    public ItemSetView() {
+      listViewItemDictionary = new Dictionary<T, ListViewItem>();
+      InitializeComponent();
+      Caption = "Item Set";
+    }
+
+    protected override void OnObjectChanged() {
+      base.OnObjectChanged();
+      Caption = "Item Set";
+      if (ItemSet != null)
+        Caption += " (" + ItemCollection.GetType().Name + ")";
+    }
+
+    protected override void AddListViewItem(ListViewItem listViewItem) {
+      ListViewItemDictionary.Add((T)listViewItem.Tag, listViewItem);
+      base.AddListViewItem(listViewItem);
+    }
+    protected override void RemoveListViewItem(ListViewItem listViewItem) {
+      base.RemoveListViewItem(listViewItem);
+      ListViewItemDictionary.Remove((T)listViewItem.Tag);
+    }
+    protected override IEnumerable<ListViewItem> GetListViewItemsForItem(T item) {
+      return new ListViewItem[] { listViewItemDictionary[item] };
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemViewBase.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemViewBase.Designer.cs	(revision 2654)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemViewBase.Designer.cs	(revision 2655)
@@ -34,8 +34,6 @@
     /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
     protected override void Dispose(bool disposing) {
-      if (Item != null)
-        RemoveItemEvents();
-      if (disposing && (components != null)) {
-        components.Dispose();
+      if (disposing) {
+        if (components != null) components.Dispose();
       }
       base.Dispose(disposing);
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemViewBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemViewBase.cs	(revision 2654)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemViewBase.cs	(revision 2655)
@@ -34,25 +34,8 @@
   /// Base class for all visual representations.
   /// </summary>
-  public partial class ItemViewBase : ViewBase, IItemView {
-    private IItem myItem;
-    /// <summary>
-    /// Gets or sets the item to represent visually.
-    /// </summary>
-    /// <remarks>Calls <see cref="OnItemChanged"/>, <see cref="Refresh"/>, 
-    /// <see cref="RemoveItemEvents"/> (if the current item is not null) and 
-    /// <see cref="AddItemEvents"/> (if the new item is not null) in the setter.</remarks>
+  public partial class ItemViewBase : ObjectViewBase {
     public IItem Item {
-      get { return myItem; }
-      protected set {
-        if (value != myItem) {
-          if (myItem != null)
-            RemoveItemEvents();
-          myItem = value;
-          if (myItem != null)
-            AddItemEvents();
-          OnItemChanged();
-          Refresh();
-        }
-      }
+      get { return (IItem)base.Object; }
+      set { base.Object = value; }
     }
 
@@ -65,77 +48,10 @@
     }
 
-    /// <summary>
-    /// Removes the eventhandlers from the current instance.
-    /// </summary>
-    protected virtual void RemoveItemEvents() { }
-    /// <summary>
-    /// Adds eventhandlers to the current instance.
-    /// </summary>
-    protected virtual void AddItemEvents() { }
-
-    /// <summary>
-    /// Refreshes the current view.
-    /// </summary>
-    /// <remarks>Creates a new <see cref="MethodInvoker"/> if an invoke is required 
-    /// (see <see cref="Control.InvokeRequired"/>.<br/>
-    /// Otherwise calls <see cref="UpdateControls"/> and <see cref="Control.Refresh"/> of base class 
-    /// <see cref="System.Windows.Forms.UserControl"/>.</remarks>
-    public override void Refresh() {
-      if (InvokeRequired) {
-        Invoke(new Action(Refresh));
+    protected override void OnObjectChanged() {
+      if (Item == null) {
+        Caption = "View";
       } else {
-        UpdateControls();
-        base.Refresh();
+        Caption = Item.ItemName;
       }
-    }
-    /// <summary>
-    /// Updates the controls with the latest values of the model.
-    /// </summary>
-    protected virtual void UpdateControls() {
-      if (Item == null)
-        Caption = "View";
-      else
-        Caption = Item.Name;
-      
-    }
-
-    /// <summary>
-    /// Occurs when the current item was changed.
-    /// </summary>
-    public event EventHandler ItemChanged;
-    /// <summary>
-    /// Fires a new <c>ItemChanged</c> event.
-    /// </summary>
-    protected virtual void OnItemChanged() {
-      if (ItemChanged != null)
-        ItemChanged(this, new EventArgs());
-    }
-
-    /// <summary>
-    /// Asynchron call of GUI updating.
-    /// </summary>
-    /// <param name="method">The delegate to invoke.</param>
-    protected new void Invoke(Delegate method) {
-      // enforce context switch to improve GUI response time
-      System.Threading.Thread.Sleep(0);
-
-      // prevent blocking of worker thread in Invoke, if the control is disposed
-      IAsyncResult result = BeginInvoke(method);
-      while ((!result.AsyncWaitHandle.WaitOne(100, false)) && (!IsDisposed)) { }
-      if (!IsDisposed) EndInvoke(result);
-    }
-    /// <summary>
-    /// Asynchron call of GUI updating.
-    /// </summary>
-    /// <param name="method">The delegate to invoke.</param>
-    /// <param name="args">The invoke arguments.</param>
-    protected new void Invoke(Delegate method, params object[] args) {
-      // enforce context switch to improve GUI response time
-      System.Threading.Thread.Sleep(0);
-
-      // prevent blocking of worker thread in Invoke, if the control is disposed
-      IAsyncResult result = BeginInvoke(method, args);
-      while ((!result.AsyncWaitHandle.WaitOne(100, false)) && (!IsDisposed)) { }
-      if (!IsDisposed) EndInvoke(result);
     }
   }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemBaseView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemBaseView.Designer.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemBaseView.Designer.cs	(revision 2655)
@@ -0,0 +1,116 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core.Views {
+  partial class NamedItemBaseView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.nameLabel = new System.Windows.Forms.Label();
+      this.nameTextBox = new System.Windows.Forms.TextBox();
+      this.descriptionLabel = new System.Windows.Forms.Label();
+      this.descriptionTextBox = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // nameLabel
+      // 
+      this.nameLabel.AutoSize = true;
+      this.nameLabel.Location = new System.Drawing.Point(3, 3);
+      this.nameLabel.Name = "nameLabel";
+      this.nameLabel.Size = new System.Drawing.Size(38, 13);
+      this.nameLabel.TabIndex = 0;
+      this.nameLabel.Text = "&Name:";
+      // 
+      // nameTextBox
+      // 
+      this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.nameTextBox.Location = new System.Drawing.Point(72, 0);
+      this.nameTextBox.Name = "nameTextBox";
+      this.nameTextBox.Size = new System.Drawing.Size(279, 20);
+      this.nameTextBox.TabIndex = 1;
+      this.nameTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.nameTextBox_Validating);
+      // 
+      // descriptionLabel
+      // 
+      this.descriptionLabel.AutoSize = true;
+      this.descriptionLabel.Location = new System.Drawing.Point(3, 29);
+      this.descriptionLabel.Name = "descriptionLabel";
+      this.descriptionLabel.Size = new System.Drawing.Size(63, 13);
+      this.descriptionLabel.TabIndex = 2;
+      this.descriptionLabel.Text = "&Description:";
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.descriptionTextBox.Location = new System.Drawing.Point(72, 26);
+      this.descriptionTextBox.Multiline = true;
+      this.descriptionTextBox.Name = "descriptionTextBox";
+      this.descriptionTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
+      this.descriptionTextBox.Size = new System.Drawing.Size(279, 62);
+      this.descriptionTextBox.TabIndex = 3;
+      this.descriptionTextBox.Validated += new System.EventHandler(this.descriptionTextBox_Validated);
+      // 
+      // NamedItemBaseView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.descriptionTextBox);
+      this.Controls.Add(this.nameTextBox);
+      this.Controls.Add(this.descriptionLabel);
+      this.Controls.Add(this.nameLabel);
+      this.Name = "NamedItemBaseView";
+      this.Size = new System.Drawing.Size(351, 88);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.TextBox nameTextBox;
+    protected System.Windows.Forms.Label nameLabel;
+    protected System.Windows.Forms.Label descriptionLabel;
+    protected System.Windows.Forms.TextBox descriptionTextBox;
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemBaseView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemBaseView.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemBaseView.cs	(revision 2655)
@@ -0,0 +1,116 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Core.Views {
+  /// <summary>
+  /// The visual representation of a <see cref="Variable"/>.
+  /// </summary>
+  [Content(typeof(NamedItemBase), true)]
+  public partial class NamedItemBaseView : ItemViewBase {
+    public NamedItemBase NamedItemBase {
+      get { return (NamedItemBase)Item; }
+      set { base.Item = value; }
+    }
+
+    public NamedItemBaseView() {
+      InitializeComponent();
+      Caption = "NamedItem";
+    }
+    public NamedItemBaseView(NamedItemBase namedItemBase)
+      : this() {
+      NamedItemBase = namedItemBase;
+    }
+
+    protected override void DeregisterObjectEvents() {
+      NamedItemBase.NameChanged -= new EventHandler(NamedItemBase_NameChanged);
+      NamedItemBase.DescriptionChanged -= new EventHandler(NamedItemBase_DescriptionChanged);
+      base.DeregisterObjectEvents();
+    }
+    protected override void RegisterObjectEvents() {
+      base.RegisterObjectEvents();
+      NamedItemBase.NameChanged += new EventHandler(NamedItemBase_NameChanged);
+      NamedItemBase.DescriptionChanged += new EventHandler(NamedItemBase_DescriptionChanged);
+    }
+
+    protected override void OnObjectChanged() {
+      base.OnObjectChanged();
+      if (NamedItemBase == null) {
+        Caption = "NamedItem";
+        nameTextBox.Text = "-";
+        nameTextBox.ReadOnly = false;
+        nameTextBox.Enabled = false;
+        descriptionTextBox.Text = "";
+        nameTextBox.ReadOnly = false;
+        descriptionTextBox.Enabled = false;
+      } else {
+        Caption = NamedItemBase.Name + " (" + NamedItemBase.GetType().Name + ")";
+        nameTextBox.Text = NamedItemBase.Name;
+        nameTextBox.ReadOnly = !NamedItemBase.CanChangeName;
+        nameTextBox.Enabled = true;
+        descriptionTextBox.Text = NamedItemBase.Description;
+        descriptionTextBox.ReadOnly = !NamedItemBase.CanChangeDescription;
+        descriptionTextBox.Enabled = true;
+      }
+    }
+
+    protected virtual void NamedItemBase_NameChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(NamedItemBase_NameChanged), sender, e);
+      else
+        nameTextBox.Text = NamedItemBase.Name;
+    }
+    protected virtual void NamedItemBase_DescriptionChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(NamedItemBase_DescriptionChanged), sender, e);
+      else
+        descriptionTextBox.Text = NamedItemBase.Description;
+    }
+
+    protected virtual void nameTextBox_Validating(object sender, CancelEventArgs e) {
+      if (NamedItemBase.CanChangeName) {
+        string oldName = NamedItemBase.Name;
+        NamedItemBase.Name = nameTextBox.Text;
+
+        // check if variable name was set successfully
+        e.Cancel = !NamedItemBase.Name.Equals(nameTextBox.Text);
+        if (e.Cancel) {
+          MessageBox.Show(this, "\"" + nameTextBox.Text + "\" is not a valid name.", "Invalid Value", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          nameTextBox.Text = oldName;
+          nameTextBox.SelectAll();
+          nameTextBox.Focus();
+        }
+      }
+    }
+    protected virtual void descriptionTextBox_Validated(object sender, EventArgs e) {
+      if (NamedItemBase.CanChangeDescription)
+        NamedItemBase.Description = descriptionTextBox.Text;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemCollectionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemCollectionView.Designer.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemCollectionView.Designer.cs	(revision 2655)
@@ -0,0 +1,65 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using System.ComponentModel;
+
+namespace HeuristicLab.Core.Views {
+  partial class NamedItemCollectionView<T> {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.SuspendLayout();
+      // 
+      // NamedItemCollectionView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.Name = "NamedItemCollectionView";
+      this.Size = new System.Drawing.Size(532, 383);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemCollectionView.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemCollectionView.cs	(revision 2655)
@@ -0,0 +1,119 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Core.Views {
+  public partial class NamedItemCollectionView<T> : ItemCollectionView<T> where T : class, INamedItem {
+    public IObservableKeyedCollection<string, T> NamedItemCollection {
+      get { return (IObservableKeyedCollection<string, T>)Object; }
+      set { base.Object = value; }
+    }
+
+    private Dictionary<T, ListViewItem> listViewItemDictionary;
+    protected Dictionary<T, ListViewItem> ListViewItemDictionary {
+      get { return listViewItemDictionary; }
+    }
+
+    public NamedItemCollectionView() {
+      listViewItemDictionary = new Dictionary<T, ListViewItem>();
+      InitializeComponent();
+      Caption = "Named Item Collection";
+    }
+
+    protected override void DeregisterObjectEvents() {
+      NamedItemCollection.ItemsReplaced -= new CollectionItemsChangedEventHandler<T>(NamedItemCollection_ItemsReplaced);
+      base.DeregisterObjectEvents();
+    }
+    protected override void RegisterObjectEvents() {
+      base.RegisterObjectEvents();
+      NamedItemCollection.ItemsReplaced += new CollectionItemsChangedEventHandler<T>(NamedItemCollection_ItemsReplaced);
+    }
+
+    protected override T CreateItem() {
+      T item = base.CreateItem();
+      if (item != null) {
+        item.Name = GetUniqueName(item.Name);
+      }
+      return item;
+    }
+    protected override void AddListViewItem(ListViewItem listViewItem) {
+      ListViewItemDictionary.Add((T)listViewItem.Tag, listViewItem);
+      base.AddListViewItem(listViewItem);
+    }
+    protected override void RemoveListViewItem(ListViewItem listViewItem) {
+      base.RemoveListViewItem(listViewItem);
+      ListViewItemDictionary.Remove((T)listViewItem.Tag);
+    }
+    protected override IEnumerable<ListViewItem> GetListViewItemsForItem(T item) {
+      return new ListViewItem[] { listViewItemDictionary[item] };
+    }
+ 
+    #region ListView Events
+    protected override void itemsListView_DragEnterOver(object sender, DragEventArgs e) {
+      base.itemsListView_DragEnterOver(sender, e);
+      if (e.Effect != DragDropEffects.None) {
+        T item = e.Data.GetData("Value") as T;
+        if ((item == null) || (NamedItemCollection.ContainsKey(item.Name)))
+          e.Effect = DragDropEffects.None;
+      }
+    }
+    #endregion
+
+    #region NamedItemCollection Events
+    private void NamedItemCollection_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<T> e) {
+      if (InvokeRequired)
+        Invoke(new CollectionItemsChangedEventHandler<T>(NamedItemCollection_ItemsReplaced), sender, e);
+      else {
+        foreach (T item in e.Items) {
+          foreach (ListViewItem listViewItem in GetListViewItemsForItem(item))
+            UpdateListViewItem(listViewItem);
+        }
+      }
+    }
+    #endregion
+
+    #region Helpers
+    protected string GetUniqueName(string originalName) {
+      if (!NamedItemCollection.ContainsKey(originalName))
+        return originalName;
+      else {
+        string name = null;
+        int index = 0;
+        do {
+          index++;
+          name = originalName + index.ToString();
+        } while (NamedItemCollection.ContainsKey(name));
+        return name;
+      }
+    }
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ObjectViewBase.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ObjectViewBase.Designer.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ObjectViewBase.Designer.cs	(revision 2655)
@@ -0,0 +1,56 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Core.Views {
+  partial class ObjectViewBase {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (Object != null) DeregisterObjectEvents();
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ObjectViewBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ObjectViewBase.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ObjectViewBase.cs	(revision 2655)
@@ -0,0 +1,120 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Xml;
+using System.Windows.Forms;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Core.Views {
+  /// <summary>
+  /// Base class for all visual representations.
+  /// </summary>
+  public partial class ObjectViewBase : ViewBase, IObjectView {
+    private object obj;
+    /// <summary>
+    /// Gets or sets the item to represent visually.
+    /// </summary>
+    /// <remarks>Calls <see cref="OnItemChanged"/>, <see cref="Refresh"/>, 
+    /// <see cref="RemoveItemEvents"/> (if the current item is not null) and 
+    /// <see cref="AddItemEvents"/> (if the new item is not null) in the setter.</remarks>
+    public object Object {
+      get { return obj; }
+      protected set {
+        if (InvokeRequired) {
+          Invoke(new Action<object>(delegate(object o) { Object = o; }), value);
+        } else {
+          if (value != obj) {
+            if (obj != null)
+              DeregisterObjectEvents();
+            obj = value;
+            OnObjectChanged();
+            if (obj != null)
+              RegisterObjectEvents();
+          }
+        }
+      }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="ViewBase"/> with the caption "View".
+    /// </summary>
+    public ObjectViewBase() {
+      InitializeComponent();
+      Caption = "View";
+    }
+
+    /// <summary>
+    /// Removes the eventhandlers from the current instance.
+    /// </summary>
+    protected virtual void DeregisterObjectEvents() { }
+    /// <summary>
+    /// Adds eventhandlers to the current instance.
+    /// </summary>
+    protected virtual void RegisterObjectEvents() { }
+
+    /// <summary>
+    /// Occurs when the current item was changed.
+    /// </summary>
+    public event EventHandler ObjectChanged;
+    /// <summary>
+    /// Fires a new <c>ItemChanged</c> event.
+    /// </summary>
+    protected virtual void OnObjectChanged() {
+      Caption = "View";
+      if (ObjectChanged != null)
+        ObjectChanged(this, new EventArgs());
+    }
+
+    /// <summary>
+    /// Asynchron call of GUI updating.
+    /// </summary>
+    /// <param name="method">The delegate to invoke.</param>
+    protected new void Invoke(Delegate method) {
+      // enforce context switch to improve GUI response time
+      System.Threading.Thread.Sleep(0);
+
+      // prevent blocking of worker thread in Invoke, if the control is disposed
+      IAsyncResult result = BeginInvoke(method);
+      while ((!result.AsyncWaitHandle.WaitOne(100, false)) && (!IsDisposed)) { }
+      if (!IsDisposed) EndInvoke(result);
+    }
+    /// <summary>
+    /// Asynchron call of GUI updating.
+    /// </summary>
+    /// <param name="method">The delegate to invoke.</param>
+    /// <param name="args">The invoke arguments.</param>
+    protected new void Invoke(Delegate method, params object[] args) {
+      // enforce context switch to improve GUI response time
+      System.Threading.Thread.Sleep(0);
+
+      // prevent blocking of worker thread in Invoke, if the control is disposed
+      IAsyncResult result = BeginInvoke(method, args);
+      while ((!result.AsyncWaitHandle.WaitOne(100, false)) && (!IsDisposed)) { }
+      if (!IsDisposed) EndInvoke(result);
+    }
+  }
+}
